#define _GNU_SOURCE
#define __USE_GNU
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>

typedef struct {
        char* str;
        int x; 
        int y;
        int mode;
} vme; 

void _init(void)
{
  char* xstr = getenv("SOF_WIDTH");
  char* ystr = getenv("SOF_HEIGHT");

  vme* videoModes;
  int x=0,y=0;


  printf("Hijacking vid_modes struct.\n");
  videoModes = dlsym(RTLD_DEFAULT, "vid_modes");
  if(videoModes==NULL)
  {
    printf("Could not find vid_modes =(\n");
  }
  
  if( xstr )
  {
    x = atoi(xstr);
    y = atoi(ystr);

    if( x > 1 && y > 1 )
    {
      videoModes[9].x=x;
      videoModes[9].y=y;
      // Mode 3 is default, so let's be nice and override that one too.-.
      videoModes[3].x=x;
      videoModes[3].y=y;

    } else {
      printf("\n\nERROR:_ You need to set SOF_HEIGHT and SOF_WIDTH in the enviroment before running.\n\n");
    }
  }
  
}
